#include "hx.h"
#include "xmalloc.h"

static struct chat __chat_list = {0,0,0,0,{0,0,0,0,0,{0}},&__chat_list.__user_list,&__chat_list.__user_list,{0}},
		   *chat_tail = &__chat_list;
struct chat *chat_list = &__chat_list, *chat_front = &__chat_list;

struct chat *
chat_new (u_int32_t cid)
{
	struct chat *chat;

	chat = xmalloc(sizeof(struct chat));
	memset(chat, 0, sizeof(struct chat));
	chat->cid = cid;
	chat->user_list = &chat->__user_list;
	chat->user_tail = &chat->__user_list;

	chat->next = 0;
	chat->prev = chat_tail;
	chat_tail->next = chat;
	chat_tail = chat;

	return chat;
}

void
chat_delete (struct chat *chat)
{
	if (chat->next)
		chat->next->prev = chat->prev;
	if (chat->prev)
		chat->prev->next = chat->next;
	if (chat_tail == chat)
		chat_tail = chat->prev;
	if (chat_front == chat)
		chat_front = &__chat_list;
	xfree(chat);
}

struct chat *
chat_with_cid (u_int32_t cid)
{
	struct chat *chatp;

	for (chatp = chat_list; chatp; chatp = chatp->next)
		if (chatp->cid == cid)
			return chatp;

	return 0;
}
