#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include "hxd.h"

void
news_send_file (struct htlc_conn *htlc)
{
	u_int8_t buf[0xffff];
	ssize_t len;
	int fd;

	if ((fd = open(htlc->newsfile, O_RDONLY)) < 0) {
		snd_strerror(htlc, errno);
		return;
	}
	len = read(fd, buf, sizeof(buf));
	if (len < 0)
		snd_strerror(htlc, errno);
	else {
		LF2CR(buf, len);
		hlwrite(htlc, HTLS_HDR_TASK, 0, 1, HTLS_DATA_NEWS, len, buf);
	}

	close(fd);
}

void
news_save_post (char *newsfile, u_int8_t *post, u_int16_t postlen)
{
	u_int8_t buf[0xffff];
	ssize_t len;
	int fd;

	if ((fd = open(newsfile, O_RDWR|O_CREAT, hxd_cfg.permissions.news_files)) < 0)
		return;
	len = read(fd, buf, sizeof(buf));
	if (len < 0)
		goto close_and_ret;
	lseek(fd, 0, SEEK_SET);
	write(fd, post, postlen);
	if (len > 0)
		write(fd, buf, len);
close_and_ret:
	close(fd);
}

void
agreement_send_file (struct htlc_conn *htlc)
{
	u_int8_t buf[0xffff];
	ssize_t len;
	int fd;

	if ((fd = open(hxd_cfg.paths.agreement, O_RDONLY)) < 0)
		return;
	len = read(fd, buf, sizeof(buf));
	if (len < 0)
		snd_strerror(htlc, errno);
	else {
		LF2CR(buf, len);
		hlwrite(htlc, HTLS_HDR_AGREEMENT, 0, 1, HTLS_DATA_AGREEMENT, len, buf);
	}

	close(fd);
}
